Summary: The shared library for the S-Lang extension language
Name: slang
Version: 2.2.3
Release: 1
License: GPLv2+
Group: System Environment/Libraries
Source0: ftp://space.mit.edu/pub/davis/slang/v2.1/%{name}-%{version}.tar.bz2
Source1: ftp://space.mit.edu/pub/davis/slang/v2.1/%{name}-%{version}.tar.bz2.asc
Patch0: %{name}-%{version}-aix.patch
URL: http://www.jedsoft.org/slang/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: libiconv >= 1.14-2
BuildRequires: libpng-devel >= 1.2.46-1
BuildRequires: oniguruma-devel >= 5.9.2-1
BuildRequires: pcre-devel >= 7.9-2
BuildRequires: readline-devel >= 5.2-3

%description
S-Lang is an interpreted language and a programming library.  The
S-Lang language was designed so that it can be easily embedded into
a program to provide the program with a powerful extension language.
The S-Lang library, provided in this package, provides the S-Lang
extension language.  S-Lang's syntax resembles C, which makes it easy
to recode S-Lang procedures in C if you need to.


%package slsh
Summary: Interpreter for S-Lang scripts
Group: Development/Languages
Requires: %{name} = %{version}-%{release}
Requires: libiconv >= 1.14-2
Requires: libpng >= 1.2.46-1
Requires: oniguruma >= 5.9.2-1
Requires: pcre >= 7.9-2
Requires: readline >= 5.2-3

%description slsh
slsh (slang-shell) is a program for interpreting S-Lang scripts. 
It supports dynamic loading of S-Lang modules and includes a readline
interface for interactive use.

This package also includes S-Lang modules that are distributed with
the S-Lang distribution.


%package devel
Summary: Development files for the S-Lang extension language
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains files which you'll need if you want to
develop S-Lang based applications.  Documentation which may help
you write S-Lang based applications is also included.

Install the slang-devel package if you want to develop applications
based on the S-Lang extension language.


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CC="cc"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"

# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

# first build the 64-bit version
export OBJECT_MODE=64
cd 64bit
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --with-readline=gnu \
    --with-x \
    --with-pcre=%{_prefix} \
    --with-onig=%{_prefix} \
    --with-png=%{_prefix} \
    --with-iconv=%{_prefix}

cd src
make %{?_smp_mflags} static
cd ..
CreateExportList -X64 lib%{name}.exp src/objs/lib%{name}.a
${CC} -qmkshrobj src/objs/lib%{name}.a -o shr64.o -bE:lib%{name}.exp -bernotok -lm
rm -f lib%{name}.exp
rm -f src/objs/lib%{name}.a
${AR} -rv src/objs/lib%{name}.a shr64.o

make %{?_smp_mflags}

# now build the 32-bit version
export OBJECT_MODE=32
cd ../32bit
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --with-readline=gnu \
    --with-x \
    --with-pcre=%{_prefix} \
    --with-onig=%{_prefix} \
    --with-png=%{_prefix} \
    --with-iconv=%{_prefix}

cd src
make %{?_smp_mflags} static
cd ..
CreateExportList -X32 lib%{name}.exp src/objs/lib%{name}.a
${CC} -qmkshrobj src/objs/lib%{name}.a -o shr.o -bE:lib%{name}.exp -bernotok -lm
rm -f lib%{name}.exp
rm -f src/objs/lib%{name}.a
${AR} -rv src/objs/lib%{name}.a shr.o

make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"

cd 64bit
export OBJECT_MODE=64
make DESTDIR=${RPM_BUILD_ROOT} install

cd ../32bit
export OBJECT_MODE=32
make DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

# create the proper AIX shared library
${AR} -rv ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a shr.o
${AR} -q  ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ../64bit/shr64.o

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc 32bit/COPYING 32bit/doc/README 32bit/changes.txt
%doc 32bit/doc/*/slang*.txt 32bit/doc/*.txt
%{_libdir}/*.a
/usr/lib/*.a


%files slsh
%defattr(-,root,system)
%doc 32bit/slsh/doc/html/slsh*.html
%config(noreplace) %{_sysconfdir}/slsh.rc
%{_bindir}/*
%{_libdir}/%{name}
%{_mandir}/man1/*
%{_datadir}/slsh
/usr/bin/*


%files devel
%defattr(-,root,system)
%doc 32bit/doc/*/cslang*.txt 32bit/doc/*/cref.txt
%{_includedir}/*
/usr/include/*


%changelog
* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.2.3-1
- updated to version 2.2.3

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.2.2-1
- updated to version 2.2.2

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.2.2-1
- updated to version 2.2.2

* Tue May 15 2012 Michael Perzl <michael@perzl.org> - 2.1.4-1
- updated to version 2.1.4

* Tue Sep 09 2008 Michael Perzl <michael@perzl.org> - 2.1.3-1
- first version for AIX V5.1 and higher
